import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useState } from 'react';
import PropTypes from 'prop-types';
import Input from '../Input';
var BASE_CLASS = 'sui-AtomInput';
var CLASS_PASSWORD = BASE_CLASS + "-password";
var CLASS_PASSWORD_TOGGLE_BUTTON = CLASS_PASSWORD + "--toggleButton";
var TEXT = 'text';
var PASSWORD = 'password';
var HIDE_LABEL = 'hide';
var SHOW_LABEL = 'show';

var Password = function Password(_ref) {
  var onChange = _ref.onChange,
      pwShowLabel = _ref.pwShowLabel,
      pwHideLabel = _ref.pwHideLabel,
      props = _objectWithoutPropertiesLoose(_ref, ["onChange", "pwShowLabel", "pwHideLabel"]);

  var _useState = useState(PASSWORD),
      type = _useState[0],
      setType = _useState[1];

  var _useState2 = useState(''),
      value = _useState2[0],
      setValue = _useState2[1];

  var toggle = function toggle() {
    var inputType = type === PASSWORD ? TEXT : PASSWORD;
    setType(inputType);
  };

  var handleChange = function handleChange(ev, _ref2) {
    var value = _ref2.value;
    setValue(value);
    onChange(ev, {
      value: value
    });
  };

  return /*#__PURE__*/React.createElement("div", {
    className: CLASS_PASSWORD
  }, /*#__PURE__*/React.createElement(Input, Object.assign({}, props, {
    onChange: handleChange,
    value: value,
    type: type
  })), /*#__PURE__*/React.createElement("div", {
    onClick: toggle,
    className: CLASS_PASSWORD_TOGGLE_BUTTON
  }, type === PASSWORD ? pwShowLabel : pwHideLabel));
};

Password.defaultProps = {
  pwShowLabel: SHOW_LABEL,
  pwHideLabel: HIDE_LABEL,
  onChange: function onChange() {}
};
export default Password;